# -*- coding: utf-8 -*-
#MoxAutoRigging 2021.12.3  Maya2022に対応するためBomなしで保存
import maya.cmds as cmds
import maya.mel as mm
import re


skelist = ['cog','head','r_wrist','l_wrist','r_foot','l_foot']
shapeList = ["Gear", "cube", "circle8", "circle20", "circleLiner", "square", "rombus", "cross", "pyramid","nail", "arrow", "triangle"]

#ボタンを押すと選択したノードをテキストに入れる
def GetText(slObj):
    if len( cmds.ls(sl=True)) == 0:sText = ""
    else:sText = str(cmds.ls(sl=True)[0])
    cmds.textField(slObj,e=True,tx=sText)

#propフォームの数を数える
def propNumCheck():
    if cmds.layout('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout',q=True, ca=True) != None: 
        lastprop = cmds.layout('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout',q=True, ca=True)[-1] 
        m = re.match('[^\d]*(\d+).*$', lastprop)#文字列から数字を抜きとり。正規表現
        if m:
            i = int( m.groups()[0] )
            return i
        else:return 0
    else:return 0
    
#presetを保存
def savePreset():
    #marfile = cmds.fileDialog2(fileFilter="*.mar", dialogStyle=2)
    mm.eval('string $sPath[] = `fileDialog2 -fileFilter \"*.mar\" -dialogStyle 2`;')
    mm.eval('$fileId=`fopen $sPath[0] \"w\"`;')
    martext = ""
    for ske in skelist:    #スケルトン名を取得
        martext = martext + "cmds.textField('%s', e=True, text='%s')"%(ske,cmds.textField(ske,q=True,text=True)) + '\\n'
    for opname in ['neck', 'shoulder', 'pelvis', 'freeze', 'color', 'ElbowParent', 'KneeParent']:
        martext = martext + "cmds.checkBox('%s',e=True, v=%r)"%(opname, cmds.checkBox(opname, q=True, v=True)) +'\\n' 
    for radioname in ['HeadParent', 'SpineParent', 'ArmParent', 'Method']:
        martext = martext + "cmds.radioButtonGrp('%s',e=True, sl=%r)"%(radioname, cmds.radioButtonGrp(radioname,q=True, sl=True)) +'\\n' 
    martext = martext + "cmds.floatSliderGrp('controllerSize',e=True, v=%r)"%cmds.floatSliderGrp("controllerSize",q=True, v=True) +'\\n'
    for name in ['All', 'COG', 'pelvis', 'R_hand', 'L_hand', 'R_elbow', 'L_elbow', 'R_shoulder', 'L_shoulder', 'R_foot', 'L_foot', 'R_knee', 'L_knee', 'R_toe', 'L_toe', 'spine', 'neck', 'head']:
        martext = martext + "cmds.optionMenuGrp('%s', e=True, sl=%r)"%(name, cmds.optionMenuGrp(name, q=True, sl=True)) +'\\n'
        martext = martext + "cmds.textField('rig_'+'%s', e=True, text='%s')"%(name, cmds.textField('rig_'+name, q=True, text=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, bgc=%r)"%(name, cmds.button(name, q=True, bgc=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, l=%s)"%(name, cmds.button(name, q=True, l=True)) +'\\n'
    martext = martext + "cmds.checkBox('FingerRigging',e=True, v=%r)"%cmds.checkBox('FingerRigging',q=True, v=True) +'\\n' 
    for name in ['R_Thumb', 'R_Index', 'R_Middle', 'R_Ring', 'R_Pinky', 'L_Thumb', 'L_Index', 'L_Middle', 'L_Ring', 'L_Pinky']:
        martext = martext + "cmds.textField('%s', e=True, text='%s')"%(name,cmds.textField(name,q=True,text=True)) + '\\n'
        martext = martext + "cmds.textField('rig_'+'%s', e=True, text='%s')"%(name, cmds.textField('rig_'+name, q=True, text=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, bgc=%r)"%(name, cmds.button(name, q=True, bgc=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, l=%s)"%(name, cmds.button(name, q=True, l=True)) +'\\n'
    martext = martext + "cmds.optionMenu('fingerShapeType', e=True, sl=%r)"%cmds.optionMenu('fingerShapeType', q=True, sl=True) +'\\n'
    i = propNumCheck()
    for u in range(i):
        martext = martext + 'addPropForm()' +'\\n'
    for u in range(1, i+1):
        print(u)
        martext = martext + "cmds.textField('%s', e=True, text='%s')"%('prop'+str(u),  cmds.textField('prop'+str(u), q=True,text=True)) + '\\n'
        martext = martext + "cmds.checkBox('%s', e=True, v=%r)"%('T_prop'+str(u),  cmds.checkBox('T_prop'+str(u), q=True, v=True)) + '\\n'        
        martext = martext + "cmds.checkBox('%s', e=True, v=%r)"%('R_prop'+str(u),  cmds.checkBox('R_prop'+str(u), q=True, v=True)) + '\\n'          
        martext = martext + "cmds.optionMenu('%s', e=True, sl=%r)"%('prop'+str(u), cmds.optionMenu('prop'+str(u), q=True, sl=True)) +'\\n'
        martext = martext + "cmds.textField('%s', e=True, text='%s')"%('rig_prop'+str(u), cmds.textField('rig_prop'+str(u), q=True, text=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, bgc=%s)"%('prop'+str(u), cmds.button('prop'+str(u), q=True, bgc=True)) +'\\n'
        martext = martext + "cmds.button('%s', e=True, l=%s)"%('prop'+str(u), cmds.button('prop'+str(u), q=True, l=True)) +'\\n'

    mm.eval('string $martext = "{}";'.format( martext))
    mm.eval('fprint $fileId $martext;')
    mm.eval('fclose $fileId;')
    #f = open(marfile[0],"w")#書き込む！
    #f.write(martext)
    #f.close()
    
#presetをロード    
def loadPreset():
    mm.eval('string $marfile[] = `fileDialog2 -fileFilter \"*.mar\" -dialogStyle 2 -okc \"open\" -fileMode 1`;')
    mm.eval('$fileId=`fopen $marfile[0] "r"`;')
    mm.eval('string $nextLine = `fgetline $fileId`;')
    mm.eval('while  (size($nextLine)  > 0 ){  python( $nextLine );  $nextLine = `fgetline $fileId`; }')
    mm.eval('fclose $fileId;')
    

    
#頭と、COGのスケルトンからスパインリストを導き出します。
def getSpineNum(head,cog,isNeck=True):
    sptop = head
    splist = []
    while sptop != cog:
        sptop = cmds.listRelatives(sptop, p=True)[0]
        splist.append( sptop )
    if isNeck==True:
        splist.pop(0)
    splist.pop()
    return splist

#ワールドローカルなどを切り替えるグループを作る。(リグの名前、ペアレントしたい親、チェックするラジオボタン）
def groupConst(name,par,radio): 
    cmds.group(n=name+"Group", em=True, p=par)
    radioCheck = cmds.radioButtonGrp(radio,q=True,select=True) 
    
    rig_All = cmds.textField("rig_All",q=True,text=True)
    rig_COG = cmds.textField("rig_COG",q=True,text=True)
    rig_spine = cmds.textField("rig_spine",q=True,text=True)
    rig_head = cmds.textField("rig_head",q=True,text=True)
    
    if  radioCheck == 1:#ローカル
        if radio == "HeadParent":
            delFit = cmds.pointConstraint(head, name+"Group")
        else:
            delFit = cmds.parentConstraint(rig_COG, name+"Group")
        cmds.delete(delFit)
        
    elif  radioCheck == 2:#ワールド
        if radio == "HeadParent" or radio == "SpineParent":
            if name == rig_head:pcn = head
            elif name == rig_spine+"1":pcn = splist[0]
            elif name == rig_spine+"2":pcn = splist[1]
            elif name == rig_spine+"3":pcn = splist[2]
            delFit = cmds.pointConstraint(pcn, name+"Group")
            cmds.delete(delFit)
            delFit = cmds.orientConstraint(rig_All, name+"Group")
        else:delFit = cmds.parentConstraint(rig_All, name+"Group")
        
    elif  radioCheck == 3:#チェスト
        lastSpine = cmds.ls(rig_spine+"*", et="transform")[-1].replace("Group","")
        cmds.parentConstraint(lastSpine, name+"Group")
        
    return name+"Group"

#jointLabel情報からマッピングを行います。
def useJointLabel():
    allSke = cmds.ls(type="joint")
    def checkLabel(num1,num2):#ラベルを探す関数
        for ske in allSke:
            if cmds.getAttr (ske+".side")==num1 and cmds.getAttr (ske+".type")==num2:
                return ske
                break
        else:return
    cmds.textField("cog",e=True, tx=checkLabel(0,1))   #COGをいれる
    cmds.textField("head",e=True, tx=checkLabel(0,8))  #headをいれる
    cmds.textField("r_wrist",e=True, tx=checkLabel(2,12))#右手をいれる 
    cmds.textField("l_wrist",e=True, tx=checkLabel(1,12))#左手をいれる
    cmds.textField("r_foot",e=True, tx=checkLabel(2,4))#右足をいれる
    cmds.textField("l_foot",e=True, tx=checkLabel(1,4))#左足をいれる
    
#カラー変更
def getColor(rigshape):
    indexV = cmds.colorIndexSliderGrp("selColorIndex", q=True, value=True )-1
    if indexV == 0:
        print(u"インデックスカラーは設定されていません")
        rgb=cmds.button(rigshape, q=True, bgc=True ) 
    else:
        rgb = cmds.colorIndex( indexV, q=True )
    cmds.button(rigshape, e=True, bgc=rgb,l=indexV ) 
    cmds.deleteUI('selectColor')  
      
#カラー変更ウインドウ
def changeColor(rigshape):
    if (cmds.window("selectColor",ex=True)):cmds.deleteUI("selectColor")
    cmds.window("selectColor")
    cmds.columnLayout()
    cmds.colorIndexSliderGrp("selColorIndex", label='Select Color', min=1, max=32, v=1)
    cmds.rowLayout(nc=2)
    cmds.button("Done", c="getColor(%r)"%rigshape)
    cmds.button("cancel", c="cmds.deleteUI('selectColor')")
    cmds.showWindow("selectColor")
    
    
#スケルトンの優先回転角をチェック
def cheackPreAng(ske):
    preAng = cmds.getAttr(ske+'.preferredAngle')[0]
    if preAng == (0,0,0):
        cmds.warning(ske+u"はスケルトンの優先回転角が設定されていません。")
    else:pass

#PropタブにPropフォームを追加する。
def addPropForm():
    cmds.setParent( 'MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout' ) #ここにいれるぜ！
    #prop最大値の数字を取り出す
    if cmds.layout('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout',q=True, ca=True) != None: 
        lastprop = cmds.layout('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout',q=True, ca=True)[-1] 

        m = re.match('[^\d]*(\d+).*$', lastprop)
        if m:
            i = int( m.groups()[0] ) +1
        else:i=1
    else:i=1
    propnum  = 'prop'+str(i) 
    propLay = cmds.formLayout(propnum)
    hoge = cmds.rowLayout(nc=4)
    cmds.button( l=propnum, command="GetText('%s')"%propnum, w=50 ) 
    cmds.textField(propnum, w=150)
    cmds.checkBox('T_'+propnum, label='T')
    cmds.checkBox('R_'+propnum, label='R')
    cmds.setParent( '..' )

    hage = cmds.rowLayout(nc=3)
    cmds.optionMenu(propnum, w=100)
    for shape in shapeList:
        cmds.menuItem( label=shape)
    cmds.optionMenu(propnum, e=True, sl=7)
    cmds.textField('rig_'+ propnum,  text='rig_'+ propnum, w=150)
    cmds.button(propnum, l=1, bgc=cmds.colorIndex( 1, q=True ), c="changeColor('%s')"%propnum, w=20,h=20)
    cmds.setParent( '..' )
    cmds.setParent( '..' )
    cmds.formLayout(propnum, edit=True, attachForm=[(hoge, 'top',5), (hage, 'top',30), (hage, 'bottom',5)])

#Propタブを削除する
def delPropForm():
    try:
        hoge = cmds.layout('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout',q=True, ca=True)[-1] 
        cmds.deleteUI('MoxAutoRigging|top|menu|tabs|proptab|propScrollLayout|'+hoge)
    except:pass
 
###    
###    
###      AutoRigのコアとなる関数です。ここでリグコントローラーを生成します。
###
###

def createCtrl(name,rigName,constSke=None,scaleV=[1,1,1],
    setIK=False, setpar=None,shapemove=[0,0,0],
    constT=False, constR=False,
    lockT=[], lockR=[],
    offsetValue=[0,0,0], rotateV=[0,0,0]):
    
    #シェイプ出力、サイズと形の調整
    if name.count('prop'):
        shapeType = cmds.optionMenu(name,q=True, v=True)
    else:
        try:shapeType = cmds.optionMenuGrp(name,q=True, v=True)
        except:shapeType = cmds.optionMenu('fingerShapeType',q=True, v=True)
    createCurve(shapeType,rigName)
    cmds.setAttr(rigName + ".rotate",rotateV[0],rotateV[1],rotateV[2])
    cmds.setAttr(rigName + ".scale",scaleV[0],scaleV[1],scaleV[2])
    cmds.makeIdentity(apply=True, s=True, r=True)#回転とスケールのフリーズ
    cmds.move(shapemove[0],shapemove[1],shapemove[2],rigName+'.ep[*]',r=True)#シェイプの移動
    
    #位置合わせ
    if constSke != None:
        chashcon= cmds.pointConstraint(constSke,rigName,offset=offsetValue)
        cmds.delete(chashcon)
        
    #IKの設定
    if setIK == True:
        stjoint = cmds.listRelatives(cmds.listRelatives(constSke,p=True)[0],p=True)[0]
        ikHandleName = cmds.ikHandle(sj=stjoint, ee=constSke,sol="ikRPsolver",n='ikHandle_' + rigName)
        cmds.parent(ikHandleName[0], rigName)
    
    #ペアレント
    if setpar != None:
        cmds.parent(rigName,setpar)
        
    #コンストレイントの設定
    if constT ==True:
        cmds.pointConstraint(rigName,constSke,maintainOffset=True)
    if constR ==True:
        cmds.orientConstraint(rigName,constSke,maintainOffset=True)
    
    #トランスレートのフリーズ
    if cmds.checkBox('freeze',q=True,v=True):
        cmds.makeIdentity(apply=True, t=True)#トランスレートのフリーズ
    
    #ロック     
    cmds.setAttr (rigName+".scale",lock=True )
    cmds.setAttr (rigName+".v",lock=True )
    if lockT == None:pass
    else:
        for v in lockT:
            cmds.setAttr (rigName+".translate"+v.upper(),lock=True )
    if lockR == None:pass
    else:
        for v in lockR:
            cmds.setAttr (rigName+".rotate"+v.upper(),lock=True )
    
    #shapeのリネーム
    d = cmds.listRelatives (rigName,s=True)[0]
    cmds.rename (rigName+"|"+d, rigName+"Shape")
    
    #color 
    if cmds.checkBox("color",q=True,v=True):
        cmds.setAttr(rigName+"Shape.overrideEnabled",1)
        cmds.setAttr(rigName+"Shape.overrideColor",int(cmds.button(name, q=True, l=True)))
        

        
####################
#メインの実行ファイル
###################
def MoxAutoRiggingBuild():
    global splist
    #スケルトン名を取得
    for ske in skelist:
        globals()[ske] = cmds.textField(ske,q=True,text=True)#globalsは文字列を変数として扱います。

    #マップに名前があるかどうかの確認
    for checkske in [cog, head, r_wrist, l_wrist, r_foot, l_foot]:
        if len(checkske) == 0:
            cmds.error(u"マッピングが不完全です。")
        elif not cmds.objExists(checkske):
            cmds.error(checkske+u"は、現在のシーンには存在しません。")
   
    if cmds.checkBox("neck",q=True,v=True):
        neck = cmds.listRelatives(head,p=True)[0]
    else:neck = head
    
    splist = getSpineNum(head,cog,isNeck=cmds.checkBox("neck",q=True,v=True)) #スパインの取得
    splist.reverse()
    spine1 = splist[0]
    print(u"スパインのリスト" + str(splist))
    
    r_Knee = cmds.listRelatives(r_foot,p=True)[0]
    l_Knee = cmds.listRelatives(l_foot,p=True)[0]
    r_Elbow = cmds.listRelatives(r_wrist,p=True)[0]
    l_Elbow = cmds.listRelatives(l_wrist,p=True)[0] 
    r_UpArm = cmds.listRelatives(r_Elbow,p=True)[0]
    l_UpArm = cmds.listRelatives(l_Elbow,p=True)[0]
    r_Shoulder = cmds.listRelatives(r_UpArm,p=True)[0]
    l_Shoulder = cmds.listRelatives(l_UpArm,p=True)[0]
    try:
        r_toe = cmds.listRelatives(r_foot,c=True, type="joint")[0]
        l_toe = cmds.listRelatives(l_foot,c=True, type="joint")[0]
    except:pass
    
    
    #Headから大体の身長を取得
    charaSize = round(cmds.xform(head,q=True, ws=True, t=True)[1],1)
    print(u"このキャラの身長は、およそ　　" + str(charaSize*1.13) + "cm")
    
    #優先回転角のチェック
    cheackPreAng(r_Knee)
    cheackPreAng(l_Knee) 
    cheackPreAng(l_Elbow) 
    cheackPreAng(l_Elbow) 
    
    #コントローラーのサイズ調整のため、身長を偽装
    controllerSize = cmds.floatSliderGrp("controllerSize",q=True, value= True)
    size = charaSize * controllerSize
    
    #リグコントローラー名を取得
    rig_All = cmds.textField("rig_All",q=True,text=True)
    rig_COG = cmds.textField("rig_COG",q=True,text=True)
    rig_pelvis = cmds.textField("rig_pelvis",q=True,text=True)
    rig_spine = cmds.textField("rig_spine",q=True,text=True)
    rig_neck = cmds.textField("rig_neck",q=True,text=True)
    rig_head = cmds.textField("rig_head",q=True,text=True)
    rig_R_hand = cmds.textField("rig_R_hand",q=True,text=True)
    rig_L_hand = cmds.textField("rig_L_hand",q=True,text=True)
    rig_R_elbow = cmds.textField("rig_R_elbow",q=True,text=True)
    rig_L_elbow = cmds.textField("rig_L_elbow",q=True,text=True)
    rig_R_shoulder = cmds.textField("rig_R_shoulder",q=True,text=True)
    rig_L_shoulder = cmds.textField("rig_L_shoulder",q=True,text=True)
    rig_R_foot = cmds.textField("rig_R_foot",q=True,text=True)
    rig_L_foot = cmds.textField("rig_L_foot",q=True,text=True)
    rig_R_knee = cmds.textField("rig_R_knee",q=True,text=True)
    rig_L_knee = cmds.textField("rig_L_knee",q=True,text=True)
    rig_R_toe = cmds.textField("rig_R_toe",q=True,text=True)
    rig_L_toe = cmds.textField("rig_L_toe",q=True,text=True)
    
    
    #All コントローラー
    s = size/2
    createCtrl('All', rig_All, scaleV=[s,s,s])

    #COG　コントローラー
    s = size/7
    createCtrl('COG', rig_COG, constSke=cog, setpar=rig_All, scaleV=[s,s,s], constT=True)

    #pelvisの　コントローラー
    s = size/12
    if cmds.checkBox('pelvis', q=True, v=True):
        createCtrl('pelvis', rig_pelvis, constSke=cog, setpar=rig_COG, scaleV=[s,s*0.6,s], shapemove=[0, s*-0.6,0], constR=True)
    else:
        cmds.orientConstraint(rig_COG, cog, maintainOffset=True)
       
    #スパイン1の　コントローラー
    s = size/10
    par = groupConst(rig_spine+"1", rig_COG, "SpineParent")
    createCtrl('spine', rig_spine+"1",
        constSke=spine1, scaleV=[s,s,s], setpar=par, shapemove=[0, s/2,0], lockT=['x','y','z'], constR=True)

    
    #スパイン１以外は量産可能
    def getSpains(num,s):
        if len(splist) >= num:
            par = groupConst(rig_spine+str(num), rig_spine+str(num-1), "SpineParent")
            createCtrl('spine', rig_spine+str(num),constSke=splist[num-1], scaleV=[s,s,s], setpar=par, 
                shapemove=[0,s/2,0], lockT=['x','y','z'], constR=True)
     
    #スパイン2の　コントローラー
    getSpains(2, size/8) 
    
    #スパイン3の　コントローラー    
    getSpains(3, size/8) 
    
    #スパイン4の　コントローラー  
    getSpains(4, size/8) 


    #首の　コントローラー
    if cmds.checkBox('neck',q=True,v=True):
        s = size/16
        createCtrl('neck', rig_neck, constSke=neck, scaleV=[s,s,s], setpar=rig_spine+str(len(splist)), 
            shapemove=[0,s/3,0], lockT=['x','y','z'], constR=True)
 
    #頭の　コントローラー
    s = size/12
    if cmds.objExists(rig_neck):#首があるなら
        hoge = rig_neck
    else:#首がないのであれば、スパインに頭を
        hoge = rig_spine+str(len(splist))
       
    groupName = groupConst(rig_head, hoge, "HeadParent")
    createCtrl('head', rig_head, constSke=head, scaleV=[s,s*1.1,s] ,setpar=groupName, 
        shapemove=[0,s/1.2,0], lockT=['x','y','z'], constR=True)
        
    
    #右足の　コントローラー
    s = size/20
    createCtrl('R_foot', rig_R_foot, 
        constSke=r_foot, setIK=True, setpar=rig_All, scaleV=[s,s/1.5,s*1.5],shapemove=[0,s/-2,0], constR=True)
        
    #左足の　コントローラー  
    createCtrl('L_foot', rig_L_foot, constSke=l_foot, setIK=True, setpar=rig_All, 
        scaleV=[s,s/1.5,s*1.5], shapemove=[0,s/-2,0], constR=True)
       
    #左右のつま先の　コントローラー
    s = size/20
    try:
        createCtrl('R_toe', rig_R_toe, constSke=r_toe, setpar=rig_R_foot, scaleV=[s,s/3,s/1.3], 
            shapemove=[0,0,s/1.2], constR=True, lockT=['x','y','z'])
        createCtrl('L_toe', rig_L_toe, constSke=l_toe ,setpar=rig_L_foot, scaleV=[s,s/3,s/1.3], 
            shapemove=[0,0,s/1.2], constR=True, lockT=['x','y','z'])
    except:pass


    #左右の膝の　コントローラー
    s = size/40
    if cmds.checkBox('KneeParent', q=True, v=True):
        parR = rig_R_foot
        parL = rig_L_foot
    else:
        parR = rig_All
        parL = rig_All
        
    createCtrl('R_knee', rig_R_knee, constSke=r_Knee, setpar=parR, scaleV=[s,s,s], lockR=['x','y','z'], offsetValue=[0,0,s*10])
    cmds.poleVectorConstraint(rig_R_knee,"ikHandle_"+rig_R_foot)

    createCtrl('L_knee', rig_L_knee, constSke=l_Knee, setpar=parL, scaleV=[s,s,s], lockR=['x','y','z'], offsetValue=[0,0,s*10])
    cmds.poleVectorConstraint(rig_L_knee,"ikHandle_"+rig_L_foot)


    #左右の手の　コントローラー 
    s = size/20
    if cmds.radioButtonGrp('Method', q=True, sl=True) == 1:
        if cmds.radioButtonGrp("ArmParent", q=True, select=True) == 1:#COG
            parR = rig_COG
            parL = rig_COG
        elif cmds.radioButtonGrp("ArmParent", q=True, select=True) == 2:#world
            parR = rig_All
            parL = rig_All
        elif cmds.radioButtonGrp("ArmParent", q=True, select=True) == 3:#chest
            parR = rig_spine+str(len(splist))
            parL = rig_spine+str(len(splist))
    else:
        parR = groupConst(rig_R_hand, rig_COG, "ArmParent")
        parL = groupConst(rig_L_hand, rig_COG, "ArmParent")
    rigrotz = cmds.xform(r_wrist, q=True, ws=True, ro=True)[2]+90
    createCtrl('R_hand', rig_R_hand, constSke=r_wrist, setIK=True, setpar=parR, scaleV=[s,s,s], rotateV=[0,0,rigrotz], constR=True)
    rigrotz = cmds.xform(l_wrist, q=True, ws=True, ro=True)[2]+90
    createCtrl('L_hand', rig_L_hand, constSke=l_wrist, setIK=True, setpar=parL, scaleV=[s,s,s], rotateV=[0,0,rigrotz], constR=True)

    #左右の肘の　コントローラー
    s = size/40
    if cmds.checkBox('ElbowParent', q=True, v=True):
        parR = rig_R_hand
        parL = rig_L_hand
    else:pass
        
    createCtrl('R_elbow', rig_R_elbow, constSke=r_Elbow, setpar=parR, scaleV=[s,s,s], lockR=['x','y','z'], offsetValue=[0,0,s*-10])
    cmds.poleVectorConstraint(rig_R_elbow,"ikHandle_"+ rig_R_hand)
    
    createCtrl('L_elbow', rig_L_elbow, constSke=l_Elbow, setpar=parL, scaleV=[s,s,s], lockR=['x','y','z'], offsetValue=[0,0,s*-10])
    cmds.poleVectorConstraint(rig_L_elbow,"ikHandle_"+ rig_L_hand)
    
    #左右の肩の　コントローラー
    if cmds.checkBox('shoulder',q=True,v=True):
        s = size/30 
        createCtrl('R_shoulder', rig_R_shoulder, constSke=r_Shoulder, setpar=rig_spine+str(len(splist)), scaleV=[s,s,s], 
            lockT=['x','y','z'], constR=True, shapemove=[s*-2,0,0])
            
        createCtrl('L_shoulder', rig_L_shoulder, constSke=l_Shoulder, setpar=rig_spine+str(len(splist)), 
            scaleV=[s,s,s], lockT=['x','y','z'], constR=True, shapemove=[s*+2,0,0])
    
    
    #リグレイヤーの設定
    cmds.createDisplayLayer(name = "layer_rig",number= 1,nr=True)
    cmds.editDisplayLayerMembers( "layer_rig", rig_All,noRecurse=True )
    
    #指のリギングを行うかチェック
    if cmds.checkBox("FingerRigging",q=True, v=True):
        #fingerR = autoFingerMapping(r_wrist)
        #fingerL = autoFingerMapping(l_wrist)   

        #指のコントローラー設定準備。グループを手首のスケルトンにペアレント（位置のみ）
        cmds.group(n="fingerRGroup", em=True, p=rig_R_hand)
        cmds.parentConstraint(r_wrist, "fingerRGroup", skipRotate=['x','y','z'])
        cmds.group(n="fingerLGroup", em=True, p=rig_L_hand)
        cmds.parentConstraint(l_wrist, "fingerLGroup", skipRotate=['x','y','z'])
        
        #指の量産
        def getFinger(skeFing, omgn, lr):   
            if  skeFing == "":pass 
            else:
                s = size/80 
                rig_name = cmds.textField("rig_"+omgn,q=True,text=True)
                fing = cmds.listRelatives(skeFing,c=True, type='joint', ad=True)

                #指1
                rigrotz = cmds.xform(skeFing, q=True, ws=True, ro=True)[2] +90
                createCtrl(omgn, rig_name+"1", constSke=skeFing, setpar="finger"+lr+"Group", scaleV=[s,s,s], rotateV=[0,0,rigrotz],
                    lockT=['x','y','z'], constR=True, shapemove=[0,0,0])

                #指2
                rigrotz = cmds.xform(fing[-1], q=True, ws=True, ro=True)[2] +90
                createCtrl(omgn, rig_name+"2", constSke=fing[-1], setpar=rig_name+"1", scaleV=[s,s,s], rotateV=[0,0,rigrotz],
                    lockT=['x','y','z'], lockR=['x','y'], constR=True, shapemove=[0,0,0])
                    
                #指3
                rigrotz = cmds.xform(fing[-2], q=True, ws=True, ro=True)[2] +90
                createCtrl(omgn, rig_name+"3", constSke=fing[-2], setpar=rig_name+"2", scaleV=[s,s,s], rotateV=[0,0,rigrotz],
                    lockT=['x','y','z'], lockR=['x','y'], constR=True, shapemove=[0,0,0])


        R_Thumb = cmds.textField('R_Thumb', q=True, text=True)
        R_Index = cmds.textField('R_Index', q=True, text=True)
        R_Middle = cmds.textField('R_Middle', q=True, text=True)
        R_Ring = cmds.textField('R_Ring', q=True, text=True)
        R_Pinky = cmds.textField('R_Pinky', q=True, text=True)
        L_Thumb = cmds.textField('L_Thumb', q=True, text=True)
        L_Index = cmds.textField('L_Index', q=True, text=True)
        L_Middle = cmds.textField('L_Middle', q=True, text=True)
        L_Ring = cmds.textField('L_Ring', q=True, text=True)
        L_Pinky = cmds.textField('L_Pinky', q=True, text=True)

        #右の指  
        getFinger(R_Thumb, 'R_Thumb','R')
        getFinger(R_Index, 'R_Index','R')
        getFinger(R_Middle, 'R_Middle','R')
        getFinger(R_Ring, 'R_Ring','R')
        getFinger(R_Pinky, 'R_Pinky','R')

        #左の指     
        getFinger(L_Thumb, 'L_Thumb','L')
        getFinger(L_Index, 'L_Index','L') 
        getFinger(L_Middle, 'L_Middle','L') 
        getFinger(L_Ring, 'L_Ring','L') 
        getFinger(L_Pinky, 'L_Pinky','L') 


        #cmds.editDisplayLayerMembers( "layer_rig", rig_All,noRecurse=True )         
    
    #Propのリギング
    print(u'propの数' + str(propNumCheck()))
    for num in range(1,propNumCheck()+1):
        try:
            prop1ske = cmds.textField('prop'+str(num), q=True, text=True)
            prop1t = cmds.checkBox('T_prop'+str(num), q=True, v=True)
            prop1r = cmds.checkBox('R_prop'+str(num), q=True, v=True)
            prop1rig = cmds.textField('rig_prop'+str(num),  q=True, text=True)
            s = size/30
            if prop1t == True:locklistT = []
            else:locklistT = ['x','y','z']
            if prop1r == True:locklistR = []
            else:locklistR = ['x','y','z']
            createCtrl( 'prop'+str(num), prop1rig, constSke=prop1ske, setpar=rig_All, constT=prop1t, constR=prop1r, 
                lockT=locklistT,  lockR=locklistR ,scaleV=[s,s,s])
            
        except:pass
    cmds.select (cl=True)
    
    
#UI生成
class MoxAutoRigging_MainWindow():
    def __init__(self):

        if (cmds.window("MoxAutoRigging",ex=True)):cmds.deleteUI("MoxAutoRigging")
        MoxAutoRigging = cmds.window("MoxAutoRigging",t="MoxAutoRigging",w=300,h=100,sizeable=True)  
        cmds.columnLayout("top")
        
        #メニューバー
        cmds.menuBarLayout("menu")
        cmds.menu( label='Presets' )
        cmds.menuItem( label='Save Preset',command="savePreset()")
        cmds.menuItem( label='Load Preset',command="loadPreset()")
        cmds.menu( label='Mapping' )
        cmds.menuItem( label='using the jointLabel',command="useJointLabel()")

        #タブ用意
        tabs = cmds.tabLayout("tabs")
        
        #
        #メインタブ
        #
        main = cmds.columnLayout("main")
        
        #マッピング
        for ske in skelist:
            cmds.rowLayout(nc=2)
            cmds.button( l=ske, command="GetText(%r)"%ske,w=100 )
            cmds.textField(ske,w=190)
            cmds.setParent( '..' )
        
        #基本オプション   
        cmds.text(l="")
        cmds.rowLayout(nc=5)
        cmds.checkBox('neck',v=True,ann=u"首の骨がないのならチェックを外してください")
        cmds.checkBox('shoulder',v=True,ann=u"肩に骨がないのならチェックを外してください")
        cmds.checkBox('pelvis',v=True,ann=u"pelvisは機能しない構造であれば。チェックを外してください")
        cmds.checkBox('freeze',v=True,ann=u"Translateを0起点にしたくない場合はチェックを外してください") 
        cmds.checkBox('color',v=True,ann=u"colorを設定したくない場合はチェックを外してください。") 
        cmds.setParent( '..' )
        
        #階層構造オプション
        form = cmds.formLayout()
        
        
        headParentType = cmds.radioButtonGrp('HeadParent',label='HeadParent', labelArray2=['local', 'world'],
         numberOfRadioButtons=2, sl=1, cl3=["left","left","left"],cw3=[80,60,50])
        
        spineParentType = cmds.radioButtonGrp('SpineParent',label='SpineParent', labelArray2=['local', 'world'], 
                numberOfRadioButtons=2,sl=1,cl3=["left","left","left"],cw3=[80,60,50])
                
        armParentType = cmds.radioButtonGrp('ArmParent', label='ArmParent', labelArray3=['COG', 'World', 'chest'],
         numberOfRadioButtons=3, sl=1, cl4=["left","left","left","left"], cw4=[80,60,70,50]) 
         
        MethodType = cmds.radioButtonGrp('Method', label='ArmParent Method', labelArray2=['hierarchy', 'constraint'],
         numberOfRadioButtons=2, sl=2, cl3=["left","left","left"], cw3=[100,80,70], 
         ann=u"""ArmParentの実現方法を選びます。
             hierarchyは階層構造のみでparentの設定を実現し、groupノードを作りません
             constraintはノードの一つ上にgroupノードを作り、そこにコンストレイントをかけ、parentを実現します。
             constraint設定時の階層構造はローカルを基準とします。""")


        #肘と膝のペアレントオプション
        elbowParentType = cmds.checkBox('ElbowParent', label='Elbow the hands of children')
        kneeParentType = cmds.checkBox('KneeParent', label='Knee the Foots of children', v=True)
        
        #コントローラーのサイズ調整
        contText = cmds.text("controller Size",align="left")
        contSlider = cmds.floatSliderGrp("controllerSize", field=True, min=0.1, max=3.0,value= 1)
        cmds.setParent( '..' )
        cmds.setParent( '..' )
        
        cmds.formLayout( form, edit=True, attachForm=[
         (headParentType, 'top',20), (headParentType, 'left', 5),
         (spineParentType, 'top',40), (spineParentType, 'left', 5),
         (armParentType,'top',60),(armParentType,'left',5),
         (MethodType,'top',80),(MethodType,'left',5),
         (elbowParentType,'top',120),(elbowParentType,'left',10),
         (kneeParentType, 'top',140), (kneeParentType, 'left', 10),
         (contText,'top',180),(contText,'left',10),
         (contSlider, 'top',200), (contSlider, 'left', 10)    ])
        
        
        #
        # CtrlCustom タブ
        #
        ctrlCustom = cmds.columnLayout("CtrlCustom")
           
        
        def ctrlCustomItem(name, rigName, indexV=1, sl=1):
            cmds.rowLayout(nc=3)
            cmds.optionMenuGrp(name, label=name,cal=[1,"left"],cat=[2,"left",-80])
            for shape in shapeList:
                cmds.menuItem( label=shape)
            cmds.textField("rig_"+name, text=rigName, w=120)
            cmds.button(name, l=indexV, bgc=cmds.colorIndex( indexV, q=True ), c="changeColor(%r)"%name, w=20,h=20)
            cmds.setParent( '..' )
            cmds.optionMenuGrp(name, e=True, sl=sl)
            
        ctrlCustomItem('All', rigName="rig_All", indexV=1, sl=3)
        ctrlCustomItem('COG', rigName="rig_COG", indexV=13, sl=1)
        ctrlCustomItem('pelvis', rigName="rig_pelvis", indexV=17, sl=2)
        ctrlCustomItem('R_hand', rigName="rig_R_hand", indexV=13, sl=2)
        ctrlCustomItem('L_hand', rigName="rig_L_hand", indexV=13, sl=2)
        ctrlCustomItem('R_elbow', rigName="rig_R_elbow", indexV=13, sl=7)
        ctrlCustomItem('L_elbow', rigName="rig_L_elbow", indexV=13, sl=7)
        ctrlCustomItem('R_shoulder', rigName="rig_R_shoulder", indexV=17, sl=2)
        ctrlCustomItem('L_shoulder', rigName="rig_L_Shoulder", indexV=17, sl=2)
        ctrlCustomItem('R_foot', rigName="rig_R_foot", indexV=13, sl=2)
        ctrlCustomItem('L_foot', rigName="rig_L_foot", indexV=13, sl=2)
        ctrlCustomItem('R_knee', rigName="rig_R_knee", indexV=13, sl=7)
        ctrlCustomItem('L_knee', rigName="rig_L_knee", indexV=13, sl=7)
        ctrlCustomItem('R_toe', rigName="rig_R_toe", indexV=17, sl=2)
        ctrlCustomItem('L_toe', rigName="rig_L_toe", indexV=17, sl=2)
        ctrlCustomItem('spine', rigName="rig_spine", indexV=17, sl=6)
        ctrlCustomItem('neck', rigName="rig_neck", indexV=17, sl=6)
        ctrlCustomItem('head', rigName="rig_head", indexV=17, sl=2)

        cmds.setParent( 'CtrlCustom' )
        cmds.setParent( '..' )
        
        #
        # fingerタブ
        #
        finger = cmds.columnLayout("finger")
        cmds.checkBox("FingerRigging", l="FingerRigging")
        

        #マッピング
        for ske in ['R_Thumb','R_Index','R_Middle','R_Ring','R_Pinky','L_Thumb','L_Index','L_Middle','L_Ring','L_Pinky']:
            cmds.rowLayout(nc=4)
            cmds.button( l=ske, command="GetText(%r)"%ske,w=70 )
            cmds.textField(ske,w=120)
            cmds.textField("rig_"+ske, text="rig_"+ske, w=100)
            indexV = 25 
            cmds.button(ske, l=indexV, bgc=cmds.colorIndex( indexV, q=True ), c="changeColor(%r)"%ske, w=20,h=20) 
            cmds.setParent( '..' )
        
        fingform = cmds.formLayout()
        fingshapes = cmds.optionMenu('fingerShapeType', w=100)
        for shape in shapeList:
            cmds.menuItem( label=shape)
        cmds.optionMenu('fingerShapeType', e=True, sl=3)
        cmds.formLayout( fingform, edit=True, attachForm=(fingshapes, 'top',20))
        cmds.setParent( '..' )
        cmds.setParent( 'finger' )

        cmds.setParent( '..' )

        
        # propタブ
        proptab = cmds.columnLayout('proptab')
        cmds.rowLayout(nc=2, columnAttach2=['left','left'], columnOffset2=[20,20])
        cmds.button('addPropForm', w=120, c="addPropForm()") 
        cmds.button('delPropForm', w=120, c="delPropForm()") 
        cmds.setParent( '..' )
        propScrollLayout = cmds.scrollLayout("propScrollLayout",horizontalScrollBarThickness=16, w=300,h=400)
        
        cmds.setParent( '..' )
        cmds.setParent( '..' )
        #タブ終わり
        
        cmds.tabLayout(  tabs, edit =True, tabLabel=[(main, 'main'), (ctrlCustom, 'CtrlCustom'), (finger, 'finger'), (proptab, 'prop')])
        cmds.setParent( '..' )
        cmds.setParent( '..' )
        
        cmds.columnLayout("columnBuild",cat=["left",50])
        av = cmds.button("Build",w=200,command="MoxAutoRiggingBuild()")
        cmds.setParent( '..' )

        cmds.setParent( '..' )
        cmds.showWindow(MoxAutoRigging)
        
MoxAutoRiggingWind = MoxAutoRigging_MainWindow()
#else:
    #cmds.error(u"認証に失敗しました")
    
#カーブコレクション    
def createCurve(curvetype,name):
    
    if curvetype == "Gear":
        cmds.curve(n=name,d=3, p=[(7.063159999999995e-09, 0.0, -0.9999999999999993), (0.10471399999999977, 0.0, -0.9904249999999993), 
        (0.12882407102178997, 0.0, -0.4773363782932529), (0.7493512451357351, 0.0, -1.0210459770416165), (0.4004839485039222, 0.0, -0.2925827128909523), 
        (1.2021889186910588, 0.0, -0.3903745831477555), (0.4971003767318445, 0.0, -2.2814918025927617e-05), (1.2017455743815635, 0.0, 0.39046551954392955),
         (0.40225732574190254, 0.0, 0.2922618763423077), (0.7427010804748283, 0.0, 1.0222369229028416), (0.15365135235878508, 0.0, 0.4728924320463258),
          (1.2797975560669288e-08, 0.0, 1.263553783951856), (-0.15365135439628774, 0.0, 0.47289243214624976), (-0.7427010799288812, 0.0, 1.0222369225031458),
          (-0.4022573258881888, 0.0, 0.29226187784117097), (-1.2017455743423666, 0.0, 0.3904655139481721), (-0.497100376742348, 0.0, -2.2861533858160244e-05), 
          (-1.2021889186882435, 0.0, -0.39037458874378944), (-0.4004839485046772, 0.0, -0.2925827113909845), (-0.7493512451355319, 0.0, -1.0210459774454548),
           (-0.12882407102184787, 0.0, -0.47733637817787017), (-0.10471399999999999, 0.0, -0.990425), (7.06316e-09, 0.0, -1.0)])

       
    elif curvetype == "cube":
        cmds.curve(n=name, d=1, p=[(1, 1, 1), (1, 1, -1), (-1, 1, -1), (-1, -1, -1), (1, -1, -1), 
        (1, 1, -1), (-1, 1, -1), (-1, 1, 1), (1, 1, 1), (1, -1, 1), (1, -1, -1), (-1, -1, -1),
         (-1, -1, 1), (1, -1, 1), (-1, -1, 1), (-1, 1, 1)])

         
    elif curvetype == "square":
        cmds.curve(n=name,d=1, p=[(1.0, 0.0, -1.0), (-1.0, 0.0, -1.0), (-1.0, 0.0, 1.0), (1.0, 0.0, 1.0), (1.0, 0.0, -1.0)] )
         
    elif curvetype == "circle8":
        cmds.circle (n=name, o=True, nr=( 0, 1, 0) , r=1 ,sections=8)
        
    elif curvetype == "circle20":
          cmds.circle (n=name, o=True, nr=( 0, 1, 0) , r=1, sections=20)
        
    elif curvetype == "circleLiner":
        cmds.curve(n=name,d=1, p=[(0.0, 0.0, -1.0), (0.258819, 0.0, -0.965926), (0.5, 0.0, -0.866025), 
        (0.707107, 0.0, -0.707107), (0.866025, 0.0, -0.5), (0.965926, 0.0, -0.258819), (1.0, 0.0, 0.0), 
        (0.965926, 0.0, 0.258819), (0.866025, 0.0, 0.5), (0.707107, 0.0, 0.707107), (0.5, 0.0, 0.866025), 
        (0.258819, 0.0, 0.965926), (0.0, 0.0, 1.0), (-0.258819, 0.0, 0.965926), (-0.5, 0.0, 0.866025), (-0.707107, 0.0, 0.707107), 
        (-0.866025, 0.0, 0.5), (-0.965926, 0.0, 0.258819), (-1.0, 0.0, 0.0), (-0.965926, 0.0, -0.258819), (-0.866025, 0.0, -0.5), 
        (-0.707107, 0.0, -0.707107), (-0.5, 0.0, -0.866025), (-0.258819, 0.0, -0.965926), (0.0, 0.0, -1.0)])

    elif curvetype == "rombus":
        cmds.curve(n=name,d=1, p=[(0.0, 1.0, 0.0), (1.0, 0.0, 0.0), (0.0, 0.0, 1.0), (-1.0, 0.0, 0.0), (0.0, 0.0, -1.0), (0.0, 1.0, 0.0), 
        (0.0, 0.0, 1.0), (0.0, -1.0, 0.0), (0.0, 0.0, -1.0), (1.0, 0.0, 0.0), (0.0, 1.0, 0.0), (-1.0, 0.0, 0.0), (0.0, -1.0, 0.0), (1.0, 0.0, 0.0)])

    elif curvetype == "cross":
        cmds.curve(n=name,d=1, p=[(1.0, 0.0, 0.5), (1.0, 0.0, -0.5), (0.5, 0.0, -0.5), (0.5, 0.0, -1.0),
        (-0.5, 0.0, -1.0), (-0.5, 0.0, -0.5), (-1.0, 0.0, -0.5), (-1.0, 0.0, 0.5),
        (-0.5, 0.0, 0.5), (-0.5, 0.0, 1.0), (0.5, 0.0, 1.0), (0.5, 0.0, 0.5), (1.0, 0.0, 0.5)])
        
    elif curvetype == "pyramid":
        cmds.curve(n=name,d=1, p=[(0.0, 2.0, 0.0), (1.0, 0.0, -1.0), (-1.0, 0.0, -1.0), (0.0, 2.0, 0.0), 
        (-1.0, 0.0, 1.0), (1.0, 0.0, 1.0), (0.0, 2.0, 0.0), (1.0, 0.0, -1.0), (1.0, 0.0, 1.0), (-1.0, 0.0, 1.0), (-1.0, 0.0, -1.0)]) 
           
        
    elif curvetype == "nail":
        cmds.curve(n=name,d=1, p=[(0.0, 0.0, 0.0), (-4.440892098500626e-16, 0.0, -3.0), (-6.661338147750939e-16, -0.707107, -3.2928929999999994), 
        (-8.881784197001252e-16, -1.0, -4.0), (-9.801524036845422e-16, -0.707107, -4.707107000000001), (-8.881784197001252e-16, 0.0, -5.0), 
        (-6.661338147750939e-16, 0.707107, -4.707107000000001), (-4.440892098500626e-16, 1.0, -4.0), (-3.5211522586564563e-16, 0.707107, -3.2928929999999994), 
        (-4.440892098500626e-16, 0.0, -3.0), (-6.661338147750939e-16, -0.707107, -3.2928929999999994), (-6.661338147750939e-16, 0.707107, -4.707107000000001), 
        (-8.881784197001252e-16, 0.0, -5.0), (-9.801524036845422e-16, -0.707107, -4.707107000000001), (-3.5211522586564563e-16, 0.707107, -3.2928929999999994)])
        
    elif curvetype == "arrow":
        cmds.curve(n=name,d=1, p=[(-1.2124003311558797e-16, 0.0, 0.99), (0.66, 0.0, 8.082668874372532e-17), 
        (0.33, 0.0, 4.041334437186266e-17), (0.33000000000000007, 0.0, -0.66), (-0.32999999999999996, 0.0, -0.66), 
        (-0.33, 0.0, -4.041334437186266e-17), (-0.66, 0.0, -8.082668874372532e-17), (-1.2124003311558797e-16, 0.0, 0.99)])
        
    elif curvetype == "triangle":
        cmds.curve(n=name,d=1, p=[(1.03923, 0.0, -0.5999999999999999), (-1.03923, 0.0, -0.6000000000000001), 
        (-1.4695761589768238e-16, 0.0, 1.2), (1.03923, 0.0, -0.5999999999999999)])   
 
    else:pass
